<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="catalog-page">

        <FiltersTop :sortOptions="sortOptions">
            <div class="filters-top-totals"><b>1 Artifact(s)</b> related to this artifact</div>
        </FiltersTop> 

        <div style="height: 40px;"></div>    

        <div>
            <div class="datatable artifact-table" v-if="artifactType === 'DatasetDatabase'">
                <div class="datatable-body">
                    <!-- Outer Loop: Render rows based on artifact type -->
                    <div 
                        class="datatable-body-row accordion-style" 
                        v-for="(artifact, artifactIndex) in artifactDetails[Number(route.params.id)]" 
                        :key="artifactIndex"
                    >
                        <div class="datatable-body-row-column-name datatable-body-row-column" :id="artifact.name">
                            <span class="catalog-item-name">Table name: {{ artifactType === 'DatasetDatabase' ? artifact.name : '' }}</span>
                        </div>
                        <div class="datatable-actions">
                            <button class="preview" @click="togglePreview(artifactIndex)"><i
                                    class="icon-arrow-down"></i></button>
                        </div>
                        <!-- Shared Artifact Preview -->  
                        <div class="datatable-body-row-preview" v-if="isPreviewVisible(artifactIndex)" >
                            <div class="artifact-details-table no-line">
                                <!-- Header -->
                                <div class="line header">
                                    <div class="first-column"></div>
                                    <div class="column">
                                        <div>Num rows</div>
                                        <div>Duplicate entries</div>
                                        <div>Duplicate entries (%)</div>
                                        <div>Completeness</div>
                                        <div>Completeness (%)</div>
                                    </div>
                                </div>

                                <!-- Loading Indicator -->
                                <div v-if="loading" class="loading-indicator">
                                    <div class="spinner"></div>
                                    <span>Loading data, please wait...</span>
                                </div>

                                <!-- Inner Loop: Render columns for each artifact -->
                                <div 
                                    class="line" 
                                    v-for="(column, columnIndex) in artifactColumns[artifact.id]" 
                                    :key="columnIndex"
                                    @click="goDetails(column.id)"
                                >
                                    <div class="first-column">
                                        {{ column.name }}
                                    </div>
                                    <div 
                                        class="column" 
                                        v-for="(quality, qualityIndex) in filteredQualityMetrics(column.qualityMeasurements)" 
                                        :key="qualityIndex"
                                    >
                                        {{ quality.value }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="datatable artifact-table" v-else>
               
                <div class="datatable-body">
                    <div class="datatable-body-row">
                        <div class="datatable-body-row-preview">
                            <div class="artifact-details-table no-line">
                                <div class="line header">
                                    <div class="first-column">
                                    </div>
                                    <div class="column">
                                        <div>
                                            Num rows
                                        </div>
                                        <div>
                                            Duplicate entries
                                        </div>
                                        <div>
                                            Duplicate entries (%)
                                        </div>
                                        <div>
                                            Completeness
                                        </div>
                                        <div>
                                            Completeness (%)
                                        </div>
                                    </div>
                                </div>
                                <div v-if="loading" class="loading-indicator">
                                    <div class="spinner"></div>
                                    <span>Loading data, please wait...</span>
                                </div>
                                <div class="line" v-for="(line, lineIndex) in artifactDetails[Number(route.params.id)]" :key="lineIndex" @click="goDetails(line.id)">
                                    <div class="first-column">
                                        {{ line.name }}
                                    </div>
                                    <div class="column" v-for="(column, columnIndex) in artifactColumns[line.id]" :key="columnIndex">
                                        <div v-for="(quality, qualityIndex) in filteredQualityMetrics(column.qualityMeasurements)" :key="qualityIndex">
                                            {{ quality.value }}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>

        
    </div>
</template>
<script setup lang="ts">
import { useRoute } from 'vue-router';
import { ref } from 'vue';
import { useArtifactStore } from '~/stores/dataStore';

const props = defineProps({
    artifactsData: {
        type: Object,
        default: () => ({ artifacts: [] })
    }
});

const route = useRoute();
const artifactStore = useArtifactStore();
const artifactType = artifactStore.artifactType;

useHead({
    title: 'Catalog - DATAMITE'
});

const loading = ref(false);
const showCreateDatasetModal = ref(false);

const close = () => {
    showCreateDatasetModal.value = false;
};

// make the function close available to emit in other components
defineExpose({ close });


const artifactDetails = ref<any[]>([]);
const artifactColumns = ref<{ [key: number]: any[] }>({});

const fetchColumnsForTable = async (tableId: number) => {
    if (!artifactColumns.value[tableId]) {
        try {
            // Fetch columns for the specific table
            const columnsResponse = await useFetchAuth(`/tables/${tableId}/columns`) as any[];

            // Assign the columns to the artifactColumns object
            artifactColumns.value[tableId] = columnsResponse;
        } catch (error) {
            console.error(`Failed to fetch columns for table ID ${tableId}`, error);
        }
    }
};


const sortOptions = ref(['Last modified first', 'Last modified last', 'Option 3']);

const previewVisible = ref<number | null>(null);

const togglePreview = async (index: number) => {
    const artifact = artifactDetails.value[Number(route.params.id)][index];

    if (previewVisible.value === index) {
        // Collapse the preview
        previewVisible.value = null;
    } else {
        // Expand the preview
        previewVisible.value = index;

        // Fetch columns only if they are not already fetched
        if (!artifactColumns.value[artifact.id]) {
            await fetchColumnsForTable(artifact.id);
        }
    }
};

const isPreviewVisible = (index: number) => {
    return previewVisible.value === index;
};

// Function to handle scrolling and toggling
const handleHashScroll = async () => {
    const hash = window.location.hash;
    let artifactIndex = null;

    if (hash) {
        const targetId = hash.substring(1); // Remove the '#' to get the ID
        const targetElement = document.getElementById(targetId);

        if (targetElement) {
            targetElement.scrollIntoView({ behavior: 'smooth' });

            // Find the index of the artifact matching the ID
            artifactIndex = artifactDetails.value[Number(route.params.id)].findIndex(
                (artifact: any) => artifact.name === targetId
            );
        }
    } else {
        // If no hash, default to the first item
        artifactIndex = 0;
    }

    // Open the preview if a valid index is found
    if (artifactIndex !== null && artifactIndex !== -1) {
        previewVisible.value = artifactIndex;
    }
};

const fetchArtifactDetails = async () => { 
    loading.value = true;
    try {
        if (artifactType === 'DatasetDatabase') {
            const tablesResponse = await useFetchAuth(`/databases/${route.params.id}/tables`) as Promise<any[]>;
            const resolvedTablesResponse = await tablesResponse;
            artifactDetails.value[Number(route.params.id)] = tablesResponse;

            if (resolvedTablesResponse.length > 0) {
                previewVisible.value = 0; // Open first table by default
                
                await fetchColumnsForTable(resolvedTablesResponse[0].id); // Fetch columns only for the first table
            }
        }else{
            const structuredFilesResponse = await (await useFetchAuth(`/structuredFiles/${route.params.id}`)) as { columns: any[] };
            const columnsResponse = await (await useFetchAuth(`/structuredFiles/${route.params.id}/columns`)) as any[];

            artifactDetails.value[Number(route.params.id)] = structuredFilesResponse.columns || [];

            artifactColumns.value = {};

            for (const column of structuredFilesResponse.columns) {
                artifactColumns.value[column.id] = columnsResponse.filter((col: any) => col.id === column.id);
            }
        }
    } catch (error) {
        console.error(`Failed to fetch details for artifact ID ${route.params.id}`, error);
    } finally {
        loading.value = false;
    }
};

onMounted(async () => {
    await fetchArtifactDetails(); // Assuming this populates artifactDetails.value

    const artifacts = artifactDetails.value[Number(route.params.id)];
    if (artifacts && artifacts.length > 0) {
        previewVisible.value = 0; // Auto-expand the first table
        
        // Only fetch columns if they haven't been fetched already
        const tableId = artifacts[0].id;
        if (!artifactColumns.value[tableId]) {
            await fetchColumnsForTable(tableId); // Fetch only if not already loaded
        }
        
        await handleHashScroll();
    }
});

// Removed the `immediate: true` option to prevent it from firing on page load
watch(
    () => artifactDetails.value[Number(route.params.id)], 
    async (newDetails) => {
        if (newDetails && newDetails.length > 0) {
            const tableId = newDetails[0].id;  // assuming table id is at the first index
            // Only fetch columns if they haven't been loaded yet
            if (!artifactColumns.value[tableId]) {
                await fetchColumnsForTable(tableId);
            }
        }
    }
);

const goDetails = (id: number) => {
    navigateTo('/catalog/artifact/column/' + id);
}

// filter quality measurements
const filteredQualityMetrics = (qualityMeasurements: any) => {
  const allowedMetrics = [
      'general.num_rows',
      'general.duplicated_entries',
      'general.duplicated_entries_percent',
      'general.completeness',
      'general.completeness_percent'
    ];
    
    // Filter out only the allowed metrics
    const filtered = qualityMeasurements.filter((q: { metric: string }) => allowedMetrics.includes(q.metric));

    // Sort the filtered metrics based on their index in the allowedMetrics array
    return filtered.sort((a: { metric: string }, b: { metric: string }) => {
    return allowedMetrics.indexOf(a.metric) - allowedMetrics.indexOf(b.metric);
    });
}

</script>